<?php
/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Users
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Biblio Component BiblioController Controller
 *
 * @package		Joomla
 * @subpackage	Biblio
 *
 */
class BiblioController extends JController
{
	var $namespace;

	/**
	 * Constructor
	 *
	 */
	function __construct()
	{
		parent::__construct();

		$app = &JFactory::getApplication();


		$option	= JRequest::getCmd('option');
		$view	= JRequest::getCmd('view');
		$layout	= JRequest::getCmd('layout', 'default');


		$this->namespace = $option . '_' . $view . '.' . $layout . '.';

		// Register the ordering request variables
		$app->getUserStateFromRequest( $this->namespace . 'filter_order',		'filter_order',		'',	'cmd' );
		$app->getUserStateFromRequest( $this->namespace . 'filter_order_Dir',	'filter_order_Dir',	'',	'word' );


		// Register the pagination request variables
		$app->getUserStateFromRequest( $this->namespace . 'limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$app->getUserStateFromRequest( $this->namespace . 'limitstart', 'limitstart', 0, 'int' );


		// In case limit has been changed, adjust limitstart accordingly
		$limit 		= $app->getUserState( $this->namespace . "limit");
		$limitstart	= $app->getUserState( $this->namespace . "limitstart");
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$app->setUserState($this->namespace . 'limitstart', $limitstart);




	}

	function can($access, $taskString)
	{
		$acl = BiblioHelper::getAcl();

		if ($acl->get($access))
			return true;

		JError::raiseWarning(403, JText::sprintf( "BIBLIO_ACL_UNAUTORIZED_TASK", $taskString) );
		$this->setRedirect(BiblioHelper::urlRequest());
		return false;
	}

	function _apply($data)
	{

		$model = $this->getModel($this->singular);

        if ($model->save($data))
        {
			JRequest::setVar('cid', $model->getId());
        	$app =& JFactory::getApplication();
			$app->enqueueMessage('DONE');
        	return array($model->_id);
		}

    	JError::raiseWarning( 1000, JText::_("ERROR") );

		return false;

	}

	function _save($data)
	{
		$model = $this->getModel($this->singular);

        if ($model->save($data))
        {
        	JRequest::setVar('cid', $model->getId());
        	$app =& JFactory::getApplication();
			$app->enqueueMessage('DONE');
        	return array($model->_id);
        }

		JError::raiseWarning( 1000, JText::_("ERROR") );

		return false;
	}

	function _delete($cid)
	{

		$model = $this->getModel($this->singular);

	    if ($model->delete($cid))
	    {
	    	JRequest::setVar('cid', 0);
        	$app =& JFactory::getApplication();
			$app->enqueueMessage('DONE');
        	return true;
	    }

        JError::raiseWarning( 1000, JText::_("ERROR") );

		return false;
	}



	function _upload($fieldName, &$post, $extensions = null, $options = array(), $dir = null)
	{
		require_once(JPATH_ADMIN_BIBLIO .DS. "classes" .DS. "upload.php");
		$config	= JComponentHelper::getParams( 'com_biblio' );

		if (!$dir)
			$dir = $config->get('upload_dir_' . $this->ctrl . '_' . $fieldName, '[COM_SITE]' .DS. 'files' .DS. $this->ctrl . '_' . $fieldName);


	//Check Remove action
		$remove	= JRequest::getCmd('__' . $fieldName . '_remove',true);
		if (in_array($remove, array('remove', 'thumbs', 'trash', 'delete')))
			$post[$fieldName] = "";


		if (in_array($remove, array('thumbs', 'trash', 'delete')))
		{
			$fileName = $post["__" . $fieldName];
			$f = (preg_match("/\[.+\]/", $fileName)?"":$dir.DS) . $fileName;
			if (!BiblioFile::deleteFile($f, $remove)){
				//Error when deleting file : TODO : ADD ERROR HANDLING HERE

			}
		}

	// Process Upload
		$uploadFile =  JRequest::getVar( $fieldName, array(), 'files','array');

		if (!$uploadFile || !$uploadFile['name'])
			return true;		// Request does not contain file to upload (in case of partial update)


		$uploadClass = new BiblioUpload($dir);
		$uploadClass->setAllowed($extensions);

		if (!$result = $uploadClass->uploadFile($uploadFile, $options))
		{
			JError::raiseWarning( 1000, JText::_("BIBLIO_CONTROLLER_THERE_WERE_SOME_UPLOAD_ERRORS") );
			$this->setRedirect(BiblioHelper::urlRequest());
			return false;
		}

		$post[$fieldName] = $result->filename;
		return true;
	}



}
