<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Users
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Biblio Component BiblioModelItem Model
 *
 * @package		Joomla
 * @subpackage	Biblio
 *
 */
class BiblioModelItem extends JModel
{
	/**
	 * id
	 *
	 * @var int
	 */
	var $_id = null;

	/**
	 * data
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * params
	 *
	 * @var array
	 */
	var $_params = null;





	/**
	 * Model mode activations
	 *
	 * @var _active
	 */
	 var $_active;

	 /**
	 * Model modes
	 *
	 * @var _active
	 */
	 var $_modes;

	/**
	 * Select object
	 *
	 * @var array
	 */
	var $_select = array();

	/**
	 * Join object
	 *
	 * @var array
	 */
	var $_join = array();

	/**
	 * Where object
	 *
	 * @var array
	 */
	var $_where = array();

	/**
	 * POST object clone
	 * Very useful to refill the object automatically
	 * This copy is cleared on call of setId();
	 *
	 * @var array
	 */
	var $_post = array();


	/**
	 * Constructor
	 *
	 */
	function __construct()
	{
		parent::__construct();
		$this->_active = array();
		$this->_modes = array('predefined');
		$this->activeAll(null);
		if ($_POST)	//Clone the post
			$this->_post = array_merge($_POST, array());
	}

	/**
	 * Method to set the identifier
	 *
	 * @access	public
	 * @param	int
	 */
	function setId($id)
	{
		$this->_id		= $id;
		$this->_data	= null;

		if ($id != 0)
			$this->_post	= null;
	}

	/**
	 * Method to get the identifier
	 *
	 * @access	public
	 * @param	int
	 */
	function getId()
	{
		return $this->_id;
	}

	/**
	 * Method to get the data object
	 * @return object
	 */
	function &getData()
	{
		if ($this->_loadData())
		{
		}
		else  $this->_initData();

		return $this->_data;
	}

	/**
	 * Method to load data
	 *
	 * @access	private
	 * @return	boolean	True on success
	 *
	 */
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{

			$query = $this->_buildQuery();

			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();

			// Overload data with post - Can be dangerous :
			//		Always do a setId() to flush post when unsure
			// Post is sent when an error occurs on save or apply task.
			if ($this->_post)
				foreach(array_keys($this->_post) as $key)
					$this->_data->$key = $this->_post[$key];


			return (boolean) $this->_data;
		}
		return true;
	}


	/**
	 * Method to initialise the data
	 *
	 * @access	private
	 * @type	abstract
	 * @return	boolean	True on success
	 */
	function _initData()
	{
		if (empty($this->_data))
		{
			$data = new stdClass();

			$data->id					= 0;
			$this->_data				= $data;

			return (boolean) $this->_data;
		}
		return true;
	}


	function activeAll($active = true)
	{
		foreach($this->_modes as $mode)
		{
			$this->active($mode, $active);
		}
	}

	function active($mode, $active = true)
	{
		$this->_active[$mode] = $active;
	}

	function addSelect($select_clause)
	{
		$this->_select[] = $select_clause;
	}

	function addJoin($join_clause)
	{
		$this->_join[] = $join_clause;
	}

	function _buildQuerySelect($select = array())
	{
		$select = array_merge($select, $this->_select);
		$select 		= ( count( $this->_select ) ? ',' . implode( ',', $this->_select ) : '' );
		return $select;
	}

	function _buildQueryJoin($join = array())
	{
		$join = array_merge($join, $this->_join);
		$join 		= ( count( $this->_join ) ? ' ' . implode( ' ', $this->_join ) : '' );
		return $join;
	}

	function _buildQueryWhere($where = array())
	{
		$where = array_merge($where, $this->_where);
		$where = ( count($where) ? ' WHERE '. implode(' AND ', $where ) : '' );

		return $where;
	}

	function _deleteFiles($cids, $fileFields)
	{
		if (!count($fileFields))
			return;

		$errors = false;
		$table = $this->getTable();

		//Delete images
		$query = "SELECT `" . implode("`, `", array_keys($fileFields))
			. "` FROM `" . $table->getTableName() . "`"
			. ' WHERE id IN ( '.$cids.' )';


		$this->_db->setQuery($query);
		$files = $this->_db->loadObjectList();


		require_once(JPATH_ADMIN_BIBLIO .DS. "classes" .DS. "file.php");
		$config	= JComponentHelper::getParams( 'com_biblio' );


		foreach($fileFields as $fieldName => $op)
		{
			$dir = $config->get('upload_dir_' . $this->_name_plur . '_' . $fieldName, '[COM_SITE]' .DS. 'files' .DS. $this->_name_plur . '_' . $fieldName);


			foreach($files as $fileObj)
			{
				$imagePath = $fileObj->$fieldName;
				if (!preg_match("/\[.+\]/", $imagePath))
					$imagePath = $dir .DS. $imagePath;
				if (!BiblioFile::deleteFile($imagePath, $op))
					$errors = true;

			}
		}

		return !$errors;
	}


}