<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Users
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Biblio Component BiblioModelList Model
 *
 * @package		Joomla
 * @subpackage	Biblio
 *
 */
class BiblioModelList extends JModel
{
	/**
	 * data array
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Pagination object
	 *
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * Model mode activations
	 *
	 * @var _active
	 */
	 var $_active;

	 /**
	 * Model modes
	 *
	 * @var _active
	 */
	 var $_modes;

	/**
	 * Select object
	 *
	 * @var array
	 */
	var $_select = array();

	/**
	 * Join object
	 *
	 * @var array
	 */
	var $_join = array();

	/**
	 * Order object
	 *
	 * @var array
	 */
	var $_order = array();

	/**
	 * Where object
	 *
	 * @var array
	 */
	var $_where = array();

	/**
	 * Extra object
	 *
	 * @var array
	 */
	var $_extra = array();

	/**
	 * GroupBy object
	 *
	 * @var array
	 */
	var $_groupby = array();



	/**
	 * Constructor
	 *
	 */
	function __construct()
	{
		parent::__construct();
		$this->_active = array();
		$this->_modes = array('filter', 'order', 'pagination', 'predefined');
		$this->activeAll(null);
	}

	/**
	 * Method to get the item data
	 *
	 * @access public
	 * @return array
	 */
	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{

			$query = $this->_buildQuery();

			if ($this->_active['pagination'])
				$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
			else
				$this->_data = $this->_getList($query);

	 	    $this->_total = $this->_getListCount($query);

		}
		return $this->_data;
	}

	/**
	 * Method to get the total number of items
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
			$this->getData();

		return $this->_total;
	}

	/**
	 * Method to get a pagination object
	 *
	 * @access public
	 * @return integer
	 */
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(),
					$this->getState('limitstart'),$this->getState('limit') );
		}
		return $this->_pagination;
	}

	/**
	 * Method to build a the query string
	 *
	 * @access public
	 * @return integer
	 */
	function _buildQuery()
	{
		//Abstract

	}

	function activeAll($active = true)
	{
		foreach($this->_modes as $mode)
		{
			$this->active($mode, $active);
		}
	}

	function active($mode, $active = true)
	{
		$this->_active[$mode] = $active;
	}

	function addSelect($select_clause)
	{
		$this->_select[] = $select_clause;
	}

	function addJoin($join_clause)
	{
		$this->_join[] = $join_clause;
	}

	function addWhere($where_clause)
	{
		$this->_where[] = $where_clause;
	}

	function addOrder($order_clause)
	{
		$this->_order[] = $order_clause;
	}

	function addExtra($extra_clause)
	{
		$this->_extra[] = $extra_clause;
	}

	function addGroupBy($groupby_clause)
	{
		$this->_groupby[] = $groupby_clause;
	}

	function _buildQuerySelect($select = array())
	{
		$select = array_merge($select, $this->_select);
		$select 		= ( count( $this->_select ) ? ',' . implode( ',', $this->_select ) : '' );
		return $select;
	}

	function _buildQueryJoin($join = array())
	{
		$join = array_merge($join, $this->_join);
		$join 		= ( count( $this->_join ) ? ' ' . implode( ' ', $this->_join ) : '' );
		return $join;
	}


	function _buildQueryWhere($where = array())
	{
		$where = array_merge($where, $this->_where);
		$where = ( count($where) ? ' WHERE '. implode(' AND ', $where ) : '' );

		return $where;
	}

	function _buildQueryOrderBy($order = array(), $pre_order = '')
	{
		$order = array();
		$filter_order		= $this->getState( 'filter_order');
		$filter_order_Dir	= $this->getState( 'filter_order_Dir');

		if (count($this->_groupby))
		{
			$groupby = array();
			foreach($this->_groupby as $group)
			{
				if ($filter_order == $group)
					$group .= ' ' . $filter_order_Dir;

				$groupby[] = $group;
			}
			$order = array_merge($order, $groupby);
		}

		if ($this->_active['order'])
		{
			if ($filter_order != '')
				$order[] = $filter_order . ' ' . $filter_order_Dir;
		}

		if ($pre_order)
			$order[] = $pre_order;

		$order = array_merge($this->_order, $order);
		$order = (count($order) ? ' ORDER BY ' . implode(',', $order) : '');

		return $order;
	}

	function _buildQueryExtra($extra = array())
	{
		$extra = array_merge($extra, $this->_extra);
		$extra 		= ( count( $this->_extra ) ? ' ' . implode( ' ', $this->_extra ) : '' );
		return $extra;
	}


}
