<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Books
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(JPATH_ADMIN_BIBLIO .DS.'classes'.DS.'jcontroller.php');


/**
 * Biblio Books Controller
 *
 * @package		Joomla
 * @subpackage	Biblio
 *
 */
class BiblioControllerBooks extends BiblioController
{
	var $ctrl = 'books';
	var $singular = 'book';

	function __construct($config = array())
	{

		parent::__construct($config);

		$app = &JFactory::getApplication();
		$this->registerTask( 'new',  'new_' );



		// Register the filtering request variables
		$app->getUserStateFromRequest( $this->namespace . 'filter_id_lender',	'filter_id_lender',	'',	'int' );





	}

	function display( )
	{
		if (!JRequest::getCmd('option',null, 'get'))
		{
			//Kill the post and rebuild the url
			$this->setRedirect(BiblioHelper::urlRequest());
			return;
		}


		parent::display();
	}

	function new_()
	{
		if (!$this->can('core.create', JText::_("JTOOLBAR_NEW")))
			return;

		$vars = array();
		//Predefine fields depending on filters values
		$app = &JFactory::getApplication();
		//id_lender > name
		$filter_id_lender = $app->getUserState( $this->namespace . "filter_id_lender");
		if ($filter_id_lender) $vars["filter_id_lender"] = $filter_id_lender;



		JRequest::setVar( 'cid', 0 );
		JRequest::setVar( 'view'  , 'book');
		JRequest::setVar( 'layout', 'book' );

		$this->setRedirect(BiblioHelper::urlRequest($vars));
	}

	function edit()
	{
		if (!$this->can('core.edit', JText::_("JTOOLBAR_EDIT")))
			return;

		$vars = array();
		JRequest::setVar( 'view'  , 'book');
		JRequest::setVar( 'layout', 'book' );

		$this->setRedirect(BiblioHelper::urlRequest($vars));
	}

	function delete()
	{
		if (!$this->can('core.delete', JText::_("JTOOLBAR_DELETE")))
			return;

		// Check for request forgeries
		JRequest::checkToken() or JRequest::checkToken('get') or jexit( 'Invalid Token' );

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        if (empty($cid))
			$cid = JRequest::getVar( 'cid', array(), 'get', 'array' );

		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseWarning(500, JText::sprintf( '_ALERT_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST_TO', strtolower(JText::_("DELETE")) ) );
			$this->setRedirect(BiblioHelper::urlRequest());
			return;
		}

		$vars = array();
		if (parent::_delete($cid))
		{
			JRequest::setVar( 'view'  , 'books');
			JRequest::setVar( 'layout', 'default' );
			JRequest::setVar( 'cid', null );

		}

		$this->setRedirect(BiblioHelper::urlRequest($vars));

	}

	function save()
	{

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$post	= JRequest::get('post');
		$post['id'] = (int) $cid[0];

		if ((((int)$cid[0] > 0) && !$this->can('core.edit', JText::_("JTOOLBAR_SAVE")))
		|| (((int)$cid[0] == 0) && !$this->can('core.create', JText::_("JTOOLBAR_SAVE"))) )
			return;


		//UPLOAD FILE : Cover
		if (!$this->_upload('cover', &$post, array(
														'image/gif' => 'gif',
														'image/jpeg' => 'jpg,jpeg',
														'image/png' => 'png')))
			return;

		if ($cid = parent::_save($post))
		{
			$vars = array();
			JRequest::setVar( 'view'  , 'books');
			JRequest::setVar( 'layout', 'default' );
			JRequest::setVar( 'cid', null );

			$this->setRedirect(BiblioHelper::urlRequest($vars));
		}
		else
			//Keep the post and stay on page
			parent::display();

	}

	function apply()
	{
		if (!$this->can('core.edit', JText::_("JTOOLBAR_APPLY")))
			return;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		$post	= JRequest::get('post');
		$post['id'] = (int) $cid[0];

		//UPLOAD FILE : Cover
		if (!$this->_upload('cover', &$post, array(
														'image/gif' => 'gif',
														'image/jpeg' => 'jpg,jpeg',
														'image/png' => 'png')))
			return;

		$vars = array();
		if ($cid = parent::_apply($post))
		{
			$vars = array();
			JRequest::setVar( 'view'  , 'book');
			JRequest::setVar( 'layout', 'book' );

			$this->setRedirect(BiblioHelper::urlRequest($vars));
		}
		else
			//Keep the post and stay on page
			parent::display();


	}



	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );


		$vars = array();
		JRequest::setVar( 'view'  , 'books');
		JRequest::setVar( 'layout', 'default' );
		JRequest::setVar( 'cid', null );

		$this->setRedirect(BiblioHelper::urlRequest($vars));

	}

	function publish()
	{
		if (!$this->can('core.edit.state', JText::_("JTOOLBAR_PUBLISH")))
			return;

		// Check for request forgeries
		JRequest::checkToken() or JRequest::checkToken('get') or jexit( 'Invalid Token' );

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        if (empty($cid))
			$cid = JRequest::getVar( 'cid', array(), 'get', 'array' );

        JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseWarning(500, JText::sprintf( "BIBLIO_ALERT_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST_TO", strtolower(JText::_("PUBLISH")) ) );
		}
		else
		{
			$model = $this->getModel('book');
	        if ($model->publish($cid)){
				$app =& JFactory::getApplication();
				$app->enqueueMessage(JText::_( 'DONE' ));

			} else
				JError::raiseWarning( 1000, JText::_("ERROR") );
		}

		$vars = array();
		JRequest::setVar( 'view'  , 'books');
		JRequest::setVar( 'layout', 'default' );
		JRequest::setVar( 'cid', null );

		$this->setRedirect(BiblioHelper::urlRequest($vars));

	}

	function unpublish()
	{
		if (!$this->can('core.edit.state', JText::_("JTOOLBAR_UNPUBLISH")))
			return;

		// Check for request forgeries
		JRequest::checkToken() or JRequest::checkToken('get') or jexit( 'Invalid Token' );

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        if (empty($cid))
			$cid = JRequest::getVar( 'cid', array(), 'get', 'array' );

        JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseWarning(500, JText::sprintf( "BIBLIO_ALERT_PLEASE_MAKE_A_SELECTION_FROM_THE_LIST_TO", strtolower(JText::_("UNPUBLISH")) ) );
		}
		else
		{
			$model = $this->getModel('book');
			if ($model->publish($cid, 0)){
				$app =& JFactory::getApplication();
				$app->enqueueMessage(JText::_( 'DONE' ));

			} else
				JError::raiseWarning( 1000, JText::_("ERROR") );

		}

		$vars = array();
		JRequest::setVar( 'view'  , 'books');
		JRequest::setVar( 'layout', 'default' );
		JRequest::setVar( 'cid', null );

		$this->setRedirect(BiblioHelper::urlRequest($vars));

	}






}