<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  JDom Class - Cook librarie    (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.0.0
* @package		Cook
* @subpackage	JDom
* @license		GNU General Public License
* @author		100% Vitamin - Jocelyn HUARD
*
*	-> You can reuse this framework for all purposes. Keep this signature. <-
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class JDomHtml extends JDom
{
	var $level = 1; 			//Namespace position
	var $fallback = 'view';		//Used for default

	var $classes = array();
	var $styles = array();
	var $selectors = array();


	var $domClass;
	var $domID;


	/*
	 * Constuctor
	 *
	 * 	@namespace 	: requested class
	 *  @options	: Configuration
	 *
	 */
	function __construct($args)
	{
		parent::__construct($args);

		$this->arg('styles', null, $args);
		$this->arg('domClass', null, $args);
		$this->arg('domId', null, $args);
	}



	function addStyle($property, $value)
	{
		$this->styles[$property] = $value;
	}

	function getStyles()
	{
		$styleStr = "";

		foreach($this->styles as $property => $value)
			$styleStr .= $property . ':' . $value . ';';

		return $styleStr;
	}

	function buildDomStyles()
	{
		$styleStr = $this->getStyles();
		if (trim($styleStr) == "")
			return '';

		return ' style="' . $styleStr . '"';
	}

	function addClass($class)
	{
		if (!in_array($class, $this->classes))
			$this->classes[] = $class;
	}

	function getDomClass()
	{
		//Reformat css classes
		/*
		 * Accepts
		 * 	[my_class,myclass]
		 * 	"my_class,myclass"
		 * 	"my_class, myclass"
		 * 	"my_class myclass"
		 * 	"my_class  myclass"
		 */


		$classes = $this->domClass;
		if (!is_array($classes))
		{
			//transform coma separator
			$classes = preg_replace("/,/", " ", $classes);
			//Trim spaces
			$classes = preg_replace("/\s+/", " ", $classes);

			$classes = explode(' ', $classes);
		}

		if (count($classes))
		foreach($classes as $class)
			$this->addClass($class);


		return implode(' ', $this->classes);


	}

	function buildDomClass()
	{
		$class = $this->getDomClass();
		if (!$class)
			return '';

		return ' class="' . $class . '"';
	}


	function buildSelectors($selectors = null)
	{

		if (!$selectors)
			$selectors = $this->selectors;


		if (is_string($selectors))
			return ' ' . $selectors;

		$html = "";

		if ($selectors)
			foreach($selectors as $key => $value)
			{
				$value = str_replace('"', "\\\"", $value);
				$html .= ' ' . $key . '="' . $value . '"';
			}

		return $html;
	}

	function embedLink($contents)
	{
		$html = "";

		$href = $this->href;


		if ((isset($this->href) || isset($this->target)) && (basename($this->dataValue) != ""))
		{
			$html .= JDom::_("html.link", array(
								'href' => (isset($this->href)?$this->href:null),
								'link_title' => (isset($this->link_title)?$this->link_title:null),
								'content' => $contents,
								'target' => (isset($this->target)?$this->target:null),
								'handler' => (isset($this->handler)?$this->handler:null),
								));

			return $html;

		}


		return $contents;

	}


}