<?php
/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  JDom Class - Cook librarie    (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.0.0
* @package		Cook
* @subpackage	JDom
* @license		GNU General Public License
* @author		100% Vitamin - Jocelyn HUARD
*
*	-> You can reuse this framework for all purposes. Keep this signature. <-
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class JDomHtmlFormInput extends JDomHtmlForm
{
	var $level = 3;				//Namespace position
	var $fallback = 'text';		//Used for default

	var $dataKey;
	var $dataObject;
	var $dataValue;

	var $validatorInsensitive = false;
	var $validatorInvert = false;

	/*
	 * Constuctor
	 * 	@namespace 	: requested class
	 *  @options	: Configuration
	 *
	 *
	 * 	@dataKey	: database field name
	 * 	@dataObject	: complete object row (stdClass)
	 * 	@dataValue	: value  default = dataObject->dataKey
	 * 	@domID		: HTML id (DOM)  default=dataKey
	 */
	function __construct($args)
	{

		parent::__construct($args);

		$this->arg('dataKey'	, 2, $args);
		$this->arg('dataObject'	, 3, $args);
		$key = $this->dataKey;
		$this->arg('dataValue'	, 4, $args, (($this->dataObject && $key)?(isset($this->dataObject->$key)?$this->dataObject->$key:null):null));
		$this->arg('domID'		, 5, $args, $this->dataKey);

//Not in arguments
		$this->arg('required' 				, null, $args, false);
		$this->arg('validatorHandler' 		, null, $args);
		$this->arg('validatorRegex' 		, null, $args);
		$this->arg('validatorMsgInfo' 		, null, $args);
		$this->arg('validatorMsgIncorrect' 	, null, $args, "JDOM_VALIDATOR_INCORRECT");
		$this->arg('validatorMsgRequired' 	, null, $args, "JDOM_VALIDATOR_REQUIRED");


		if (isset($this->validatorRegex))
		{

			if (substr($this->validatorRegex, 0, 1) == '!')
			{
				$this->validatorRegex = substr($this->validatorRegex, 1);
				$this->validatorInvert = true;
			}

			//Last char is a 'i' modifier
			if (substr(strrev($this->validatorRegex), 0, 1) == 'i')
			{
				$this->validatorRegex = substr($this->validatorRegex, 0, strlen($this->validatorRegex) - 1);
				$this->validatorInsensitive = true;
			}

			//Trim slashes
			$this->validatorRegex = trim($this->validatorRegex, "/");


		}


		$this->addClass('inputbox');

		if (isset($this->required) && $this->required)
			$this->addClass('required');

		if (isset($this->validatorHandler) && $this->validatorHandler)
			$this->addClass('validate-' . $this->validatorHandler);

	}

	function addValidatorHandler($regex= null, $handler = null)
	{
		if (!$handler && isset($this->validatorHandler))
			$handler = $this->validatorHandler;

		if (!$regex && isset($this->validatorRegex))
			$regex = $this->validatorRegex;

		//Escape quotes now because escapes has been automaticaly removed.
		$regex = str_replace('"', '\\"', $regex);

		if ((!$handler) || (!$regex))
			return;

		$jsRegex = $this->reformateRegexForJS($regex);

		$script = 	'window.addEvent("domready", function() {' .LN
				.	'	document.formvalidator.setHandler("' . $handler . '", function(value, el) {' .LN;

		if($this->validatorInsensitive)
			$script .=	'		var regex = new RegExp("' . $jsRegex . '", \'i\');' .LN;
		else
			$script .=	'		var regex = new RegExp("' . $jsRegex . '");' .LN;

		if($this->validatorInvert)
			$script .=	'		return !regex.test(value);' .LN;
		else
			$script .=	'		return regex.test(value);' .LN;


		$script .=	'	});' .LN
				.	'});';


		$doc =& JFactory::getDocument();
		$doc->addScriptDeclaration($script);
	}

	function reformateRegexForJS($regex)
	{
		$regex = preg_replace("/\\\\/", "\\\\\\\\", $regex);
		return $regex;
	}

	function buildValidatorMessage()
	{
		$html = '<div class="field_message" style="clear:left;"'
			.		' id="field_message_' . $this->dataKey . '">';


		//Field is required
		if (isset($this->required) && $this->required
			&& isset($this->validatorMsgRequired))
		{
			$html	.=	'<span class="message_required" id="message_' . $this->dataKey . '_required" style="display:none;">'
				.		$this->JText($this->validatorMsgRequired)
				.		'</span>';
		}




		if (isset($this->validatorHandler))
		{
			//Message if field is empty
			if (isset($this->validatorMsgInfo))
			{
				$html	.=	'<span class="message_info" id="message_' . $this->dataKey . '_info" style="display:none;">'
					.		$this->JText($this->validatorMsgInfo)
					.		'</span>';
			}


			//Validator returns wrong
			if (isset($this->validatorMsgIncorrect))
			{
				$html	.=	'<span class="message_incorrect" id="message_' . $this->dataKey . '_incorrect" style="display:none;">'
					.		$this->JText($this->validatorMsgIncorrect)
					.		'</span>';
			}
		}

		$html	.=	'</div>';

		return $html;
	}

	function buildValidatorIcon()
	{
		if ((!isset($this->required) || !$this->required) && !isset($this->validatorHandler))
			return '';


		$html = '<div class="validatoricon"'
			.	' id="validatoricon_' . $this->dataKey . '"'
			.	' style="display:inline-block">'
			.	'</div>';


		return $html;
	}

	function parseVars($vars = array())
	{
		return array_merge(array(
				'DOM_ID'		=> $this->domID,
				'INPUT_NAME'	=> $this->dataKey,
				'STYLE'		=> $this->buildDomStyles(),
				'CLASS'			=> $this->buildDomClass(),		//With attrib name
				'CLASSES'		=> $this->getDomClass(),		// Only classes
				'SELECTORS'		=> $this->buildSelectors(),
				'VALUE'			=> htmlspecialchars($this->dataValue, ENT_COMPAT, 'UTF-8'),
				'MESSAGE' 		=> $this->buildValidatorMessage(),
				'VALIDOR_ICON' 	=> $this->buildValidatorIcon(),
				'JSON_REL' 		=> htmlspecialchars($this->jsonArgs(), ENT_COMPAT, 'UTF-8'),
				), $vars);
	}


	function buildJS()
	{
		$this->addValidatorHandler();
	}


}