<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Books
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/



// no direct access
defined('_JEXEC') or die('Restricted access');


/**
* Biblio Table class
*
* @package		Joomla
* @subpackage	Biblio
*
*/
class TableBook extends JTable
{

	/**
	 * Primary Key
	 *
	 * @var int
	 */
	var $id = null;

	/**
	 * @var string
	 */
	var $params = null;

	/**
	 * @var string
	 */
	var $cover = null;
	/**
	 * @var string
	 */
	var $bookname = null;
	/**
	 * @var int
	 */
	var $id_lender = null;
	/**
	 * @var string
	 */
	var $author = null;
	/**
	 * @var string
	 */
	var $price = null;
	/**
	 * @var string
	 */
	var $description = null;
	/**
	 * @var int
	 */
	var $publish = null;






	/**
	* Constructor
	*
	* @param object Database connector object
	*
	*/
	function __construct(& $db)
	{
		parent::__construct('#__biblio_books', 'id', $db);
	}




	/**
	* Overloaded bind function
	*
	* @acces public
	* @param array $hash named array
	* @return null|string	null is operation was satisfactory, otherwise returns an error
	* @see JTable:bind
	*
	*/
	function bind($array, $ignore = '')
	{

		if (key_exists( 'params', $array ) && is_array( $array['params'] ))
		{
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}

		return parent::bind($array, $ignore);
	}

	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @access public
	 * @return boolean True on success
	 * @see JTable:check
	 */
	function check()
	{
		$valid = true;

		$filter = new JFilterInput(array(), array(), 0, 0);
		$this->cover = $filter->clean($this->cover, 'STRING');
		$this->bookname = $filter->clean($this->bookname, 'STRING');
		$this->id_lender = $filter->clean($this->id_lender, 'INT');
		$this->author = $filter->clean($this->author, 'STRING');
		$this->price = $filter->clean($this->price, 'STRING');
		$this->description = $filter->clean($this->description, 'STRING');
		$this->publish = $filter->clean($this->publish, 'INT');


		if (!empty($this->bookname) && !preg_match("/^.{0,100}$/", $this->bookname)){
			JError::raiseWarning( 1000, JText::sprintf("BIBLIO_VALIDATOR_WRONG_VALUE_FOR_PLEASE_RETRY", JText::_("BIBLIO_FIELD_BOOKNAME")) );
			$valid = false;
		}
		if (!empty($this->price) && !preg_match("/^-?\d*\.?\d*$/", $this->price)){
			JError::raiseWarning( 1000, JText::sprintf("BIBLIO_VALIDATOR_WRONG_VALUE_FOR_PLEASE_RETRY", JText::_("BIBLIO_FIELD_PRICE")) );
			$valid = false;
		}





		if (($this->bookname === null) || ($this->bookname === '')){
			JError::raiseWarning(2001, JText::sprintf("BIBLIO_VALIDATOR_A_NAME_IS_REQUIRED", JText::_("BIBLIO_FIELD_BOOKNAME")));
			$valid = false;
		}




		return $valid;
	}
}
