<?php
/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Books
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

defined('_JEXEC') or die('Restricted access');



$isNew		= ($this->book->id < 1);
$actionText = $isNew ? JText::_( "BIBLIO_NEW" ) : JText::_( "BIBLIO_EDIT" );
?>

<fieldset class="fieldsform">
	<legend><?php echo $actionText;?></legend>

	<table class="admintable">

		<tr>
			<td align="right" class="key">
				<label for="cover">
					<?php echo JText::_( "BIBLIO_FIELD_COVER" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.file.remove', array(
												'dataKey' => 'cover',
												'dataObject' => $this->book,
												'actions' => array('remove', 'thumbs', 'trash', 'delete')
												));
				?>

				<?php echo JDom::_('html.form.input.file', array(
												'dataKey' => 'cover',
												'dataObject' => $this->book,
												'size' => "",
												'indirect' => true,
												'root' => '[DIR_BOOKS_COVER]',
												'width' => 200,
												'height' => 200
												));
				?>
			</td>
		</tr>
		<tr>
			<td align="right" class="key">
				<label for="bookname">
					<?php echo JText::_( "BIBLIO_FIELD_BOOK_NAME" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.text', array(
												'dataKey' => 'bookname',
												'dataObject' => $this->book,
												'size' => "32",
												'required' => true,
												'validatorMsgRequired' => "BIBLIO_VALIDATOR_A_NAME_IS_REQUIRED",
												'validatorHandler' => "length_100",
												'validatorRegex' => "/^.{0,100}$/"
												));
				?>
			</td>
		</tr>
		<tr>
			<td align="right" class="key">
				<label for="id_lender">
					<?php echo JText::_( "BIBLIO_FIELD_LENDER" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.select', array(
												'dataKey' => 'id_lender',
												'dataObject' => $this->book,
												'list' => $this->lists['fk']['id_lender'],
												'listKey' => 'id',
												'labelKey' => 'name',
												'nullLabel' => "BIBLIO_JSEARCH_SELECT_ID_LENDER"
												));
				?>
			</td>
		</tr>
		<tr>
			<td align="right" class="key">
				<label for="author">
					<?php echo JText::_( "BIBLIO_FIELD_AUTHOR" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.text', array(
												'dataKey' => 'author',
												'dataObject' => $this->book,
												'size' => "32"
												));
				?>
			</td>
		</tr>
		<tr>
			<td align="right" class="key">
				<label for="price">
					<?php echo JText::_( "BIBLIO_FIELD_PRICE" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.text', array(
												'dataKey' => 'price',
												'dataObject' => $this->book,
												'size' => "32",
												'validatorHandler' => "decimal",
												'validatorRegex' => "/^-?\d*\.?\d*$/"
												));
				?>
			</td>
		</tr>
		<tr>
			<td align="right" class="key">
				<label for="description">
					<?php echo JText::_( "BIBLIO_FIELD_DESCRIPTION" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.text', array(
												'dataKey' => 'description',
												'dataObject' => $this->book,
												'size' => "32"
												));
				?>
			</td>
		</tr>
		<tr>
			<td align="right" class="key">
				<label for="publish">
					<?php echo JText::_( "BIBLIO_FIELD_PUBLISH" ); ?> :
				</label>
			</td>
			<td>
				<?php echo JDom::_('html.form.input.bool', array(
												'dataKey' => 'publish',
												'dataObject' => $this->book,
												'aclAccess' => 'core.edit.state'
												));
				?>
			</td>
		</tr>


	</table>
</fieldset>
