<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Books
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/



// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Biblio component
 *
 * @static
 * @package		Joomla
 * @subpackage	Books
 *
 */
class BiblioViewBook extends JView
{
	function display($tpl = null)
	{
		$layout = $this->getLayout();
		switch($layout)
		{
			case 'book':

				$fct = "display_" . $layout;
				$this->$fct($tpl);
				break;
		}

	}
	function display_book($tpl = null)
	{
		$app = &JFactory::getApplication();
		$option	= JRequest::getCmd('option');

		$user 	=& JFactory::getUser();

		$access = BiblioHelper::getACL();

		$model	=& $this->getModel();
		$model->activeAll();
		$model->active('predefined', 'book');

		$document	= &JFactory::getDocument();
		$document->title = $document->titlePrefix . JText::_("BIBLIO_LAYOUT_BOOK") . $document->titleSuffix;


		//Form validator
		JHTML::_('behavior.formvalidation');


		$lists = array();

		//get the book
		$book	=& $this->get('data');
		$isNew		= ($book->id < 1);


		$model_id_lender =& JModel::getInstance('lenders', 'BiblioModel');
		$model_id_lender->addGroupBy("a.name");
		$lists['fk']['id_lender'] = $model_id_lender->getData();



		// Toolbar
		jimport('joomla.html.toolbar');
		$bar = & JToolBar::getInstance('toolbar');
		if (!$isNew && $access->get('core.delete'))
			$bar->appendButton( 'Standard', "delete", "JTOOLBAR_DELETE", "delete", false);
		if ($access->get('core.edit') || ($isNew && $access->get('core.create')))
			$bar->appendButton( 'Standard', "save", "JTOOLBAR_SAVE", "save", false);
		if ($access->get('core.edit'))
			$bar->appendButton( 'Standard', "apply", "JTOOLBAR_APPLY", "apply", false);
		$bar->appendButton( 'Standard', "cancel", "JTOOLBAR_CANCEL", "cancel", false, false );



		$lists['params'] = $this->getParams($book->params);

		$file 	= JPATH_COMPONENT.DS.'models'.DS.'book.xml';
		$params = new JParameter( $book->params, $file );
		$config	= JComponentHelper::getParams( 'com_biblio' );


		JRequest::setVar( 'hidemainmenu', true );

		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('access',		$access);
		$this->assignRef('lists',		$lists);
		$this->assignRef('book',		$book);
		$this->assignRef('params',		$params);
		$this->assignRef('config',		$config);
		$this->assignRef('isNew',		$isNew);

		parent::display($tpl);
	}

	function getParams($params)
	{
		$parameters = array();
		$parametres = explode("\n", $params);
		foreach($parametres as $p)
		{
			if (trim($p) != "")
			{
				$pa = explode("=", $p);
				$parameters[$pa[0]] = $pa[1];
			}
		}

		return $parameters;
	}


}