<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Lenders
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/



// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Biblio component
 *
 * @static
 * @package		Joomla
 * @subpackage	Lenders
 *
 */
class BiblioViewLenders extends JView
{
	/*
	 * Define here the default list limit
	 */
	protected $_default_limit = null;

	function display($tpl = null)
	{
		$app = &JFactory::getApplication();
		$config =& JFactory::getConfig();

		$option	= JRequest::getCmd('option');
		$view	= JRequest::getCmd('view');
		$layout = $this->getLayout();


		$model =& $this->getModel();

		$namespace = $option . '_' . $view . '.' . $layout . '.';
		$statesVars = array('limitstart', 'filter_order', 'filter_order_Dir');

		// Default list limit value from config, or from protected property
		if (is_null($app->getUserState( $namespace . 'limit')))
			$model->setState('limit', ($this->_default_limit?$this->_default_limit:($config->getValue('config.list_limit'))));
		else
			$model->setState('limit', $app->getUserState( $namespace . 'limit'));

		foreach($statesVars as $var)
			$model->setState($var, $app->getUserState( $namespace . $var));

		$model->setState('namespace', $namespace);

		switch($layout)
		{
			case 'default':

				$fct = "display_" . $layout;
				$this->$fct($tpl);
				break;
		}

	}
	function display_default($tpl = null)
	{
		$app = &JFactory::getApplication();
		$option	= JRequest::getCmd('option');

		$user 	=& JFactory::getUser();

		$access = BiblioHelper::getACL();

		$document	= &JFactory::getDocument();
		$document->title = $document->titlePrefix . JText::_("BIBLIO_LAYOUT_LENDERS") . $document->titleSuffix;


		// Get data from the model
		$model 		=& $this->getModel();
		$model->activeAll();
		$model->active('predefined', 'default');
		$model->active("publish", false);





		$items		=& $model->getData();

		$total		=& $this->get( 'Total');
		$pagination =& $this->get( 'Pagination' );



		// table ordering
		$lists['order'] = $model->getState('filter_order');
		$lists['order_Dir'] = $model->getState('filter_order_Dir');


		// Toolbar
		jimport('joomla.html.toolbar');
		$bar = & JToolBar::getInstance('toolbar');
		if ($access->get('core.create'))
			$bar->appendButton( 'Standard', "new", "JTOOLBAR_NEW", "new", false);
		if ($access->get('core.edit'))
			$bar->appendButton( 'Standard', "edit", "JTOOLBAR_EDIT", "edit", true);
		if ($access->get('core.delete'))
			$bar->appendButton( 'Standard', "delete", "JTOOLBAR_DELETE", "delete", true);
        $bar->appendButton('Popup', 'options', JText::_('JTOOLBAR_OPTIONS'), 'index.php?option=com_config&amp;view=component&amp;component=' . $option . '&amp;path=&amp;tmpl=component');



		//Filters


		$config	= JComponentHelper::getParams( 'com_biblio' );


		$this->assignRef('user',		JFactory::getUser());
		$this->assignRef('access',		$access);
		$this->assignRef('lists',		$lists);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('config',		$config);

		parent::display($tpl);
	}





}