<?php

/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Books
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMIN_BIBLIO .DS.'classes'.DS.'jmodel.list.php');


/**
 * Biblio Component Books Model
 *
 * @package		Joomla
 * @subpackage	Biblio
 *
 */
class BiblioModelBooks extends BiblioModelList
{
	var $_name_sing = 'book';



	/**
	 * Constructor
	 *
	 */
	function __construct()
	{
		parent::__construct();
		$this->_modes = array_merge($this->_modes, array('publish'));


	}



	/**
	 * Method to build a the query string for the Book
	 *
	 * @access public
	 * @return integer
	 */
	function _buildQuery()
	{

		if (isset($this->_active['predefined']))
		switch($this->_active['predefined'])
		{
			case 'default': return $this->_buildQuery_default(); break;

		}



		$query = ' SELECT a.*'

			. $this->_buildQuerySelect()

			. ' FROM `#__biblio_books` AS a '

			. $this->_buildQueryJoin() . ' '

			. $this->_buildQueryWhere()


			. $this->_buildQueryOrderBy()
			. $this->_buildQueryExtra()
		;

		return $query;
	}

	function _buildQuery_default()
	{

		$query = ' SELECT a.*'
					.	' , _id_lender_.name AS `_id_lender_name`'

			. $this->_buildQuerySelect()

			. ' FROM `#__biblio_books` AS a '
					.	' LEFT JOIN `#__biblio_lenders` AS _id_lender_ ON _id_lender_.id = a.id_lender'

			. $this->_buildQueryJoin() . ' '

			. $this->_buildQueryWhere()


			. $this->_buildQueryOrderBy()
			. $this->_buildQueryExtra()
		;

		return $query;
	}



	function _buildQueryWhere()
	{
		$where = array();

		$app = &JFactory::getApplication();
		$db=& JFactory::getDBO();
		$option	= JRequest::getCmd('option');
		$view	= JRequest::getCmd('view');
		$layout	= JRequest::getCmd('layout', 'default');

		$baseUserState = $option . '_' . $view . '.' . $layout . '.';

		if (isset($this->_active['filter']) && $this->_active['filter'])
		{
			$filter_id_lender = $this->getState('filter_id_lender');
			if ($filter_id_lender != '')		$where[] = "_id_lender_.id = " . (int)$filter_id_lender . "";


		}
		if (!isset($this->_active['publish']) || $this->_active['publish'] !== false)	$where[] = "a.publish=1";



		return parent::_buildQueryWhere($where);
	}

	function _buildQueryOrderBy()
	{
		$order = array();
		$pre_order = 'a.bookname';

		return parent::_buildQueryOrderBy($order, $pre_order);
	}


}
