<?php
/**                               ______________________________________________
*                          o O   |                                              |
*                 (((((  o      <  Generated with Cook           (100% Vitamin) |
*                ( o o )         |______________________________________________|
* --------oOOO-----(_)-----OOOo---------------------------------- www.j-cook.pro --- +
* @version		1.6
* @package		biblio_v1.0
* @subpackage	Users
* @copyright	Copyright 2012, All rights reserved
* @author		Marc Letouzé - www.protolbv.fr/jbreeding - marc.letouze@liubov.net
* @license		GNU/GPL
*
* /!\  Joomla! is free software.
* This version may have been modified pursuant to the GNU General Public License,
* and as distributed it includes or is derivative of works licensed under the
* GNU General Public License or other free or open source software licenses.
*
*             .oooO  Oooo.     See COPYRIGHT.php for copyright notices and details.
*             (   )  (   )
* -------------\ (----) /----------------------------------------------------------- +
*               \_)  (_/
*/

defined('_JEXEC') or die;


/**
 * Build the route for the com_biblio component
 *
 * @param	array	An array of URL arguments
 *
 * @return	array	The URL arguments to use to assemble the subsequent URL.
 */
function BiblioBuildRoute(&$query){

	$segments = array();
	if(isset($query['view']))
	{
		$view = $query['view'];
		$segments[] = $view;
		unset( $query['view'] );
	}

	if(isset($query['layout']))
	{
		$segments[] = $query['layout'];
		unset( $query['layout'] );
	}


	if(isset($query['cid']))
	{
		if(in_array($view, array('bookdescription')))
		{
			$segments[] = (is_array($query['cid'])?implode(',', $query['cid']):$query['cid']);
			unset( $query['cid'] );
		}
	};


	return $segments;
}


/**
 * Parse the segments of a URL.
 *
 * @param	array	The segments of the URL to parse.
 *
 * @return	array	The URL attributes to be used by the application.
 */
function BiblioParseRoute($segments)
{
	$vars = array();


	$vars['view'] = $segments[0];
	$vars['layout'] = $segments[1];

	$nextPos = 2;

	//Item layout : get the cid value
	if(in_array($vars['view'], array('bookdescription')))
	{
			$slug = $segments[$nextPos];
			$id = explode( ':', $slug );
			$vars['cid'] = (int) $id[0];

			$nextPos++;
	}

	return $vars;
}

